# Rose: How to Contribute

## Report Bugs

Report bugs and request enhancement by opening an issue on
[Rose issues @ Github](https://github.com/metomi/rose/issues). If reporting a
bug, add a recipe for repeating it. If requesting an enhancement,
describe the use case in detail.

## Contribute Code

All contributions to Rose are made via pull requests against the *master*
branch of [metomi/rose](https://github.com/metomi/rose). New contributors
should add their details to the [Code Contributors](#code-contributors)
section of this file as part of their first request. The developer who
reviews each pull request is responsible for checking that the
contributor's name is listed in this file before merging the pull request
into *master*.

## Code Contributors

The following people have contributed to this code under the terms of
the Contributor Licence Agreement and Certificate of Origin detailed
below:

* Andrew Clark (Met Office, UK)
* Kerry Day (Met Office, UK)
* Martin Dix (CSIRO, Australia)
* Ben Fitzpatrick (Met Office, UK)
* Craig MacLachlan (Met Office, UK)
* Joseph Mancell (Met Office, UK)
* Dave Matthews (Met Office, UK)
* Hilary Oliver (National Institute of Water and Atmospheric Research, New Zealand)
* Annette Osprey (NCAS Computational Modelling Services, UK)
* Stephen Oxley (Met Office, UK)
* Matt Pryor (Met Office, UK)
* Oliver Sanders (Met Office, UK)
* Jon Seddon (Met Office, UK)
* Harry Shepherd (Met Office, UK)
* Matt Shin (Met Office, UK)
* Stuart Whitehouse (Met Office, UK)
* Steve Wardle (Met Office, UK)
* Scott Wales (ARC Centre of Excellence for Climate Systems Science, Australia)

(All contributors are identifiable with email addresses in the version control
logs or otherwise.)

## Contributor Licence Agreement and Certificate of Origin

By making a contribution to this project, I certify that:

(a) The contribution was created in whole or in part by me and I have
    the right to submit it, either on my behalf or on behalf of my
    employer, under the terms and conditions as described by this file;
    or

(b) The contribution is based upon previous work that, to the best of
    my knowledge, is covered under an appropriate licence and I have
    the right or permission from the copyright owner under that licence
    to submit that work with modifications, whether created in whole or
    in part by me, under the terms and conditions as described by
    this file; or

(c) The contribution was provided directly to me by some other person
    who certified (a) or (b) and I have not modified it.

(d) I understand and agree that this project and the contribution
    are public and that a record of the contribution (including my
    name and email address) is maintained indefinitely and may be
    redistributed consistent with this project or the licence(s)
    involved.

(e) I, or my employer, grant to the UK Met Office and all recipients of
    this software a perpetual, worldwide, non-exclusive, no-charge,
    royalty-free, irrevocable copyright licence to reproduce, modify,
    prepare derivative works of, publicly display, publicly perform,
    sub-licence, and distribute this contribution and such modifications
    and derivative works consistent with this project or the licence(s)
    involved or other appropriate open source licence(s) specified by
    the project and approved by the
    [Open Source Initiative (OSI)](http://www.opensource.org/).

(f) If I become aware of anything that would make any of the above
    inaccurate, in any way, I will let the UK Met Office know as soon as
    I become aware.

(The Rose Contributor Licence Agreement and Certificate of Origin is
inspired by the Certificate of Origin used by Enyo and the Linux
Kernel.)
